> For the complete documentation index, see [llms.txt](https://docs.emsigner.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.emsigner.com/apis/api-reference/users-and-accounts/external-user.md).

# External User

## POST /api/Public/ExternalUser/AdhocUser

> Adhoc user

```json
{"openapi":"3.0.1","info":{"title":"emSigner Core API","version":"v1"},"tags":[{"name":"ExternalUser"}],"servers":[{"url":"https://demoapi-core.emsigner.com","description":"Demo / Sandbox"},{"url":"{baseUrl}","description":"Custom environment","variables":{"baseUrl":{"default":"https://demoapi-core.emsigner.com","description":"Base URL of your emSigner environment (e.g. production or on-prem API host)"}}}],"security":[{"Bearer":[]}],"components":{"securitySchemes":{"Bearer":{"type":"http","description":"JWT access token from POST /auth/token. Paste the token without the \"Bearer \" prefix.","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"emSignerCoreAPI.Shared.DTOs.CreateAdhocUserRequestDto":{"required":["email","name"],"type":"object","properties":{"name":{"maxLength":150,"minLength":1,"type":"string"},"email":{"maxLength":150,"minLength":1,"type":"string","format":"email"},"contactNumber":{"maxLength":20,"type":"string","format":"tel","nullable":true},"dob":{"type":"string","format":"date-time","nullable":true},"genderId":{"pattern":"^(1|2)$","type":"string","nullable":true},"pan":{"maxLength":10,"pattern":"^[A-Z]{5}[0-9]{4}[A-Z]$","type":"string","nullable":true},"organization":{"maxLength":200,"type":"string","nullable":true},"identificationNumber":{"maxLength":50,"type":"string","nullable":true},"alternativeEmail":{"maxLength":150,"type":"string","format":"email","nullable":true},"countryCode":{"maxLength":5,"type":"string","nullable":true},"isAutoApproved":{"type":"boolean"},"browserInfo":{"$ref":"#/components/schemas/emSignerCoreAPI.Shared.DTOs.BrowserInfo"},"password":{"type":"string","nullable":true},"externalUserPhoto":{"type":"string","format":"byte","nullable":true},"isEncrypted":{"type":"boolean"},"isActiveByPermissionId":{"type":"integer","format":"int32","nullable":true},"hsmProfileId":{"type":"string","nullable":true},"requestSource":{"type":"integer","format":"int32"},"parentId":{"type":"integer","format":"int32","nullable":true},"isAutoGeneratedEmail":{"type":"boolean"},"documentId":{"type":"integer","format":"int32","nullable":true}},"additionalProperties":false},"emSignerCoreAPI.Shared.DTOs.BrowserInfo":{"type":"object","properties":{"browserName":{"type":"string","nullable":true},"browserVersion":{"type":"string","nullable":true},"osName":{"type":"string","nullable":true},"osVersion":{"type":"string","nullable":true},"device":{"type":"string","nullable":true},"ipAddress":{"type":"string","nullable":true},"timeZone":{"type":"string","nullable":true}},"additionalProperties":false},"emSignerCoreAPI.ViewModels.ReturnObject`1[[emSignerCoreAPI.Shared.DTOs.CreateAdhocUserResponseDto, emSignerCoreAPI, Version=3.0.5.1, Culture=neutral, PublicKeyToken=null]]":{"type":"object","properties":{"isSuccess":{"type":"boolean"},"messages":{"type":"array","items":{"type":"string"},"nullable":true},"errorCode":{"type":"integer","format":"int32"},"errorKey":{"type":"string","nullable":true},"response":{"$ref":"#/components/schemas/emSignerCoreAPI.Shared.DTOs.CreateAdhocUserResponseDto"}},"additionalProperties":false},"emSignerCoreAPI.Shared.DTOs.CreateAdhocUserResponseDto":{"type":"object","properties":{"subscriberId":{"type":"integer","format":"int64"},"isSuccess":{"type":"boolean"},"message":{"type":"string","nullable":true},"email":{"type":"string","nullable":true},"name":{"type":"string","nullable":true},"externalSubID":{"type":"integer","format":"int32","nullable":true},"opId":{"type":"integer","format":"int32"},"certificateProfiles":{"type":"string","nullable":true},"browserInfo":{"$ref":"#/components/schemas/emSignerCoreAPI.Shared.DTOs.BrowserInfo"}},"additionalProperties":false}}},"paths":{"/api/Public/ExternalUser/AdhocUser":{"post":{"tags":["ExternalUser"],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/emSignerCoreAPI.Shared.DTOs.CreateAdhocUserRequestDto"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/emSignerCoreAPI.ViewModels.ReturnObject`1[[emSignerCoreAPI.Shared.DTOs.CreateAdhocUserResponseDto, emSignerCoreAPI, Version=3.0.5.1, Culture=neutral, PublicKeyToken=null]]"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/emSignerCoreAPI.ViewModels.ReturnObject`1[[emSignerCoreAPI.Shared.DTOs.CreateAdhocUserResponseDto, emSignerCoreAPI, Version=3.0.5.1, Culture=neutral, PublicKeyToken=null]]"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/emSignerCoreAPI.ViewModels.ReturnObject`1[[emSignerCoreAPI.Shared.DTOs.CreateAdhocUserResponseDto, emSignerCoreAPI, Version=3.0.5.1, Culture=neutral, PublicKeyToken=null]]"}}}},"409":{"description":"Conflict","content":{"application/json":{"schema":{"$ref":"#/components/schemas/emSignerCoreAPI.ViewModels.ReturnObject`1[[emSignerCoreAPI.Shared.DTOs.CreateAdhocUserResponseDto, emSignerCoreAPI, Version=3.0.5.1, Culture=neutral, PublicKeyToken=null]]"}}}},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/emSignerCoreAPI.ViewModels.ReturnObject`1[[emSignerCoreAPI.Shared.DTOs.CreateAdhocUserResponseDto, emSignerCoreAPI, Version=3.0.5.1, Culture=neutral, PublicKeyToken=null]]"}}}}},"summary":"Adhoc user","operationId":"post_ExternalUser_AdhocUser"}}}}
```

## POST /api/Public/ExternalUser/FormSubmitter

> Form submitter

```json
{"openapi":"3.0.1","info":{"title":"emSigner Core API","version":"v1"},"tags":[{"name":"ExternalUser"}],"servers":[{"url":"https://demoapi-core.emsigner.com","description":"Demo / Sandbox"},{"url":"{baseUrl}","description":"Custom environment","variables":{"baseUrl":{"default":"https://demoapi-core.emsigner.com","description":"Base URL of your emSigner environment (e.g. production or on-prem API host)"}}}],"security":[{"Bearer":[]}],"components":{"securitySchemes":{"Bearer":{"type":"http","description":"JWT access token from POST /auth/token. Paste the token without the \"Bearer \" prefix.","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"emSignerCoreAPI.Shared.DTOs.CreateFormSubmitterRequest":{"type":"object","properties":{"templateId":{"type":"integer","format":"int32"},"linkId":{"type":"integer","format":"int64"},"email":{"type":"string","nullable":true},"name":{"type":"string","nullable":true}},"additionalProperties":false}}},"paths":{"/api/Public/ExternalUser/FormSubmitter":{"post":{"tags":["ExternalUser"],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/emSignerCoreAPI.Shared.DTOs.CreateFormSubmitterRequest"}}}},"responses":{"200":{"description":"OK"}},"summary":"Form submitter","operationId":"post_ExternalUser_FormSubmitter"}}}}
```

## POST /api/Public/ExternalUser/approve-external-user

> Approve external user

```json
{"openapi":"3.0.1","info":{"title":"emSigner Core API","version":"v1"},"tags":[{"name":"ExternalUser"}],"servers":[{"url":"https://demoapi-core.emsigner.com","description":"Demo / Sandbox"},{"url":"{baseUrl}","description":"Custom environment","variables":{"baseUrl":{"default":"https://demoapi-core.emsigner.com","description":"Base URL of your emSigner environment (e.g. production or on-prem API host)"}}}],"security":[{"Bearer":[]}],"components":{"securitySchemes":{"Bearer":{"type":"http","description":"JWT access token from POST /auth/token. Paste the token without the \"Bearer \" prefix.","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"emSignerCoreAPI.CoreApi.Public.Controllers.ApproveExternalUserRequest":{"type":"object","properties":{"externalUserId":{"type":"integer","format":"int32"},"reason":{"type":"string","nullable":true},"browserInfo":{"$ref":"#/components/schemas/emSignerCoreAPI.Shared.DTOs.BrowserInfo"}},"additionalProperties":false},"emSignerCoreAPI.Shared.DTOs.BrowserInfo":{"type":"object","properties":{"browserName":{"type":"string","nullable":true},"browserVersion":{"type":"string","nullable":true},"osName":{"type":"string","nullable":true},"osVersion":{"type":"string","nullable":true},"device":{"type":"string","nullable":true},"ipAddress":{"type":"string","nullable":true},"timeZone":{"type":"string","nullable":true}},"additionalProperties":false}}},"paths":{"/api/Public/ExternalUser/approve-external-user":{"post":{"tags":["ExternalUser"],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/emSignerCoreAPI.CoreApi.Public.Controllers.ApproveExternalUserRequest"}}}},"responses":{"200":{"description":"OK"}},"summary":"Approve external user","operationId":"post_ExternalUser_approve_external_user"}}}}
```

## POST /api/Public/ExternalUser/reject-external-user

> Reject external user

```json
{"openapi":"3.0.1","info":{"title":"emSigner Core API","version":"v1"},"tags":[{"name":"ExternalUser"}],"servers":[{"url":"https://demoapi-core.emsigner.com","description":"Demo / Sandbox"},{"url":"{baseUrl}","description":"Custom environment","variables":{"baseUrl":{"default":"https://demoapi-core.emsigner.com","description":"Base URL of your emSigner environment (e.g. production or on-prem API host)"}}}],"security":[{"Bearer":[]}],"components":{"securitySchemes":{"Bearer":{"type":"http","description":"JWT access token from POST /auth/token. Paste the token without the \"Bearer \" prefix.","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"emSignerCoreAPI.CoreApi.Public.Controllers.ApproveExternalUserRequest":{"type":"object","properties":{"externalUserId":{"type":"integer","format":"int32"},"reason":{"type":"string","nullable":true},"browserInfo":{"$ref":"#/components/schemas/emSignerCoreAPI.Shared.DTOs.BrowserInfo"}},"additionalProperties":false},"emSignerCoreAPI.Shared.DTOs.BrowserInfo":{"type":"object","properties":{"browserName":{"type":"string","nullable":true},"browserVersion":{"type":"string","nullable":true},"osName":{"type":"string","nullable":true},"osVersion":{"type":"string","nullable":true},"device":{"type":"string","nullable":true},"ipAddress":{"type":"string","nullable":true},"timeZone":{"type":"string","nullable":true}},"additionalProperties":false}}},"paths":{"/api/Public/ExternalUser/reject-external-user":{"post":{"tags":["ExternalUser"],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/emSignerCoreAPI.CoreApi.Public.Controllers.ApproveExternalUserRequest"}}}},"responses":{"200":{"description":"OK"}},"summary":"Reject external user","operationId":"post_ExternalUser_reject_external_user"}}}}
```

## POST /api/Public/ExternalUser/get-user/{mappingId}

> Get user

```json
{"openapi":"3.0.1","info":{"title":"emSigner Core API","version":"v1"},"tags":[{"name":"ExternalUser"}],"servers":[{"url":"https://demoapi-core.emsigner.com","description":"Demo / Sandbox"},{"url":"{baseUrl}","description":"Custom environment","variables":{"baseUrl":{"default":"https://demoapi-core.emsigner.com","description":"Base URL of your emSigner environment (e.g. production or on-prem API host)"}}}],"security":[{"Bearer":[]}],"components":{"securitySchemes":{"Bearer":{"type":"http","description":"JWT access token from POST /auth/token. Paste the token without the \"Bearer \" prefix.","scheme":"bearer","bearerFormat":"JWT"}}},"paths":{"/api/Public/ExternalUser/get-user/{mappingId}":{"post":{"tags":["ExternalUser"],"parameters":[{"name":"mappingId","in":"path","required":true,"schema":{"type":"integer","format":"int32"}}],"responses":{"200":{"description":"OK"}},"summary":"Get user","operationId":"post_ExternalUser_get_user_mappingId"}}}}
```

## POST /api/Public/ExternalUser/update-user

> Update user

```json
{"openapi":"3.0.1","info":{"title":"emSigner Core API","version":"v1"},"tags":[{"name":"ExternalUser"}],"servers":[{"url":"https://demoapi-core.emsigner.com","description":"Demo / Sandbox"},{"url":"{baseUrl}","description":"Custom environment","variables":{"baseUrl":{"default":"https://demoapi-core.emsigner.com","description":"Base URL of your emSigner environment (e.g. production or on-prem API host)"}}}],"security":[{"Bearer":[]}],"components":{"securitySchemes":{"Bearer":{"type":"http","description":"JWT access token from POST /auth/token. Paste the token without the \"Bearer \" prefix.","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"emSignerCoreAPI.Shared.DTOs.UpdateUserRequestDto":{"required":["mappingId","name"],"type":"object","properties":{"mappingId":{"type":"integer","format":"int32"},"name":{"maxLength":50,"minLength":1,"type":"string"},"organization":{"maxLength":50,"type":"string","nullable":true},"mobileNumber":{"type":"string","nullable":true},"alternativeEmail":{"type":"string","format":"email","nullable":true},"nationalId":{"maxLength":100,"type":"string","nullable":true},"externalUserPhoto":{"type":"string","format":"byte","nullable":true},"hsmProfileId":{"maxLength":200,"type":"string","nullable":true},"requestSource":{"type":"integer","format":"int32"},"dob":{"type":"string","format":"date-time","nullable":true},"pan":{"maxLength":45,"pattern":"^[A-Z]{5}[0-9]{4}[A-Z]$","type":"string","nullable":true},"gender":{"maxLength":45,"pattern":"^(1|2)$","type":"string","nullable":true},"countryCode":{"maxLength":45,"type":"string","nullable":true},"browserInfo":{"$ref":"#/components/schemas/emSignerCoreAPI.Shared.DTOs.BrowserInfo"}},"additionalProperties":false},"emSignerCoreAPI.Shared.DTOs.BrowserInfo":{"type":"object","properties":{"browserName":{"type":"string","nullable":true},"browserVersion":{"type":"string","nullable":true},"osName":{"type":"string","nullable":true},"osVersion":{"type":"string","nullable":true},"device":{"type":"string","nullable":true},"ipAddress":{"type":"string","nullable":true},"timeZone":{"type":"string","nullable":true}},"additionalProperties":false}}},"paths":{"/api/Public/ExternalUser/update-user":{"post":{"tags":["ExternalUser"],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/emSignerCoreAPI.Shared.DTOs.UpdateUserRequestDto"}}}},"responses":{"200":{"description":"OK"}},"summary":"Update user","operationId":"post_ExternalUser_update_user"}}}}
```

## POST /api/Public/ExternalUser/get-users

> Get users

```json
{"openapi":"3.0.1","info":{"title":"emSigner Core API","version":"v1"},"tags":[{"name":"ExternalUser"}],"servers":[{"url":"https://demoapi-core.emsigner.com","description":"Demo / Sandbox"},{"url":"{baseUrl}","description":"Custom environment","variables":{"baseUrl":{"default":"https://demoapi-core.emsigner.com","description":"Base URL of your emSigner environment (e.g. production or on-prem API host)"}}}],"security":[{"Bearer":[]}],"components":{"securitySchemes":{"Bearer":{"type":"http","description":"JWT access token from POST /auth/token. Paste the token without the \"Bearer \" prefix.","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"emSignerCoreAPI.CoreApi.Public.Controllers.GetUsersRequest":{"type":"object","properties":{"name":{"type":"string","nullable":true},"email":{"type":"string","nullable":true},"alternativeEmail":{"type":"string","nullable":true},"contactNumber":{"type":"string","nullable":true},"organization":{"type":"string","nullable":true},"nationalId":{"type":"string","nullable":true},"status":{"type":"string","nullable":true},"createdDate":{"type":"string","format":"date-time","nullable":true},"rejectedBy":{"type":"string","nullable":true},"remarks":{"type":"string","nullable":true},"createdBy":{"type":"string","nullable":true},"updatedOn":{"type":"string","format":"date-time","nullable":true},"sortColumn":{"type":"string","nullable":true},"sortOrder":{"type":"string","nullable":true},"pageNumber":{"type":"integer","format":"int32","nullable":true},"pageSize":{"type":"integer","format":"int32","nullable":true},"searchText":{"type":"string","nullable":true}},"additionalProperties":false}}},"paths":{"/api/Public/ExternalUser/get-users":{"post":{"tags":["ExternalUser"],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/emSignerCoreAPI.CoreApi.Public.Controllers.GetUsersRequest"}}}},"responses":{"200":{"description":"OK"}},"summary":"Get users","operationId":"post_ExternalUser_get_users"}}}}
```

## POST /api/Public/ExternalUser/delete-user

> Delete user

```json
{"openapi":"3.0.1","info":{"title":"emSigner Core API","version":"v1"},"tags":[{"name":"ExternalUser"}],"servers":[{"url":"https://demoapi-core.emsigner.com","description":"Demo / Sandbox"},{"url":"{baseUrl}","description":"Custom environment","variables":{"baseUrl":{"default":"https://demoapi-core.emsigner.com","description":"Base URL of your emSigner environment (e.g. production or on-prem API host)"}}}],"security":[{"Bearer":[]}],"components":{"securitySchemes":{"Bearer":{"type":"http","description":"JWT access token from POST /auth/token. Paste the token without the \"Bearer \" prefix.","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"emSignerCoreAPI.CoreApi.Public.Controllers.DeleteUserRequestDto":{"type":"object","properties":{"userId":{"maximum":2147483647,"minimum":1,"type":"integer","format":"int32"},"browserInfo":{"$ref":"#/components/schemas/emSignerCoreAPI.Shared.DTOs.BrowserInfo"}},"additionalProperties":false},"emSignerCoreAPI.Shared.DTOs.BrowserInfo":{"type":"object","properties":{"browserName":{"type":"string","nullable":true},"browserVersion":{"type":"string","nullable":true},"osName":{"type":"string","nullable":true},"osVersion":{"type":"string","nullable":true},"device":{"type":"string","nullable":true},"ipAddress":{"type":"string","nullable":true},"timeZone":{"type":"string","nullable":true}},"additionalProperties":false}}},"paths":{"/api/Public/ExternalUser/delete-user":{"post":{"tags":["ExternalUser"],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/emSignerCoreAPI.CoreApi.Public.Controllers.DeleteUserRequestDto"}}}},"responses":{"200":{"description":"OK"}},"summary":"Delete user","operationId":"post_ExternalUser_delete_user"}}}}
```
